from classes import Job, Memory, MemoryBlock, Scheduler
 
def main():
    """
    Create memory address space, and desired memory segments.
    Create desired processes of arbitrary length and add to job queue.
    Initiate the memory scheduler with the memory address space, and
    schedule jobs to run with selected policy: first fit or best fit.
    When finished, display memory block metadata and memory space status.
    """
    memspace = Memory(0x30ff)
    m0 = MemoryBlock(0, 0x64)
    m1 = MemoryBlock(1, 0x4b)
    m2 = MemoryBlock(2, 0x37) 
    m3 = MemoryBlock(3, 0x7b) 
    m4 = MemoryBlock(4, 0x1539)
    m5 = MemoryBlock(5, 0x80)
    m6 = MemoryBlock(6, 0x200)
    m7 = MemoryBlock(7, 0x1000)
    memspace.create_segments([m0, m1, m2, m3, m4, m5, m6, m7])
    # memspace._blocks.extend([m0, m1, m2, m3, m4, m5, m6, m7])

    p0 = Job(0, 0x3e8)
    p1 = Job(1, 0x1e)
    p2 = Job(2, 0x63)
    p3 = Job(3, 0x4a)
    p4 = Job(4, 0x15)
    p5 = Job(5, 0x45)
    p6 = Job(6, 0x28)
    p7 = Job(7, 0x3c)
    p8 = Job(8, 0x40)
    p9 = Job(9, 0x12ff)
    queue = [p0, p1, p2, p3, p4, p5, p6, p7, p8, p9]

    memscheduler = Scheduler(memspace)
    # memscheduler.run_bestfit(queue)
    memscheduler.run_firstfit(queue)

    for b in memspace._blocks:
        print(b)
    print(memspace)

if __name__ == "__main__":
    main()